
QGIS Application - Bug report #16043

WFS-T Broken in QGIS 2.18.* with Geoserver Endpoints

2017-01-06 12:17 AM - Giovanni Manghi

Status: Closed

Priority: Severe/Regression

Assignee: Alessandro Pasotti

Category: Web Services clients/WFS

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: fixed/implemented

Crashes QGIS or corrupts data:No Copied to github as #: 23958

Description

Works as expected on LTR.

Tested with several datasources, PostGIS included.

Associated revisions

Revision 502a8da4 - 2017-01-14 04:08 PM - Alessandro Pasotti 

[bugfix] WFS-T Fixes #15597 #16043

Tested on GeoServer and QGIS Server

Needs forward port to master

Revision 93770b1c - 2017-01-14 04:27 PM - Alessandro Pasotti 

Merge pull request #3989 from elpaso/wfst-200-fix-15597

[bugfix] WFS-T fixes #15597 #16043 geoserver compatibility

Revision 9324bdac - 2017-01-16 11:38 AM - Alessandro Pasotti 

[bugfix] WFS-T Fixes #15597 #16043

This commit fixes a few bugs on WFS-T with

servers that support WFS-T > 1.0.0 when user

configure version != 1.0.0 ("auto" is the default).

It also fixes WFS-T multiple operations on GeoServer

when an insert operation is among them and the feature

store does not return generated feature ids for the

inserted features (i.e. shapefiles).

Tested on GeoServer and QGIS Server

(cherry-picked from 502a8da40380)
Revision 39a5f6a4 - 2017-01-16 11:55 AM - Alessandro Pasotti 

Merge pull request #3999 from elpaso/wfst-fixes-15597-16043

[bugfix] WFS-T Fixes #15597 #16043

History

#1 - 2017-01-06 12:21 AM - Giovanni Manghi

Works as expected using QGIS Server.

To replicate just fire a Geoserver instance (tested 2.8 and 2.9 here), import a layer, enable wfs-t.

#2 - 2017-01-13 05:04 AM - Alessandro Pasotti

- Assignee set to Alessandro Pasotti

- Affected QGIS version changed from 2.18.2 to master

Confirmed: 

2.14 WFS-T works fine with QGIS Server and GeoServer

2.18 WFS-T works fine with QGIS Server and fails with GeoServer

master WFS-T works fine with QGIS Server and fails with GeoServer

#3 - 2017-01-13 05:46 AM - Giovanni Manghi

it work if forcing version to 1.0.

#4 - 2017-01-13 07:39 AM - Alessandro Pasotti

Basically: WFS-T is only implemented for 1.0.0, unfortunately the user does not know that because the developer did not implement any way to warn the

user.

What happens is that GeoServer supports 1.0.0, 1.1.0 and 2.0.0, the default "auto" value will fetch the highests.

qgswfscapabilities.cpp line 478 (2.18):

// TODO: remove me when WFS-T 1.1 or 2.0 is done

  if ( !mCaps.version.startsWith( "1.0" ) )

    return;

Quick fix: change the default value in the WFS dialog from "auto" to 1.0.0 until the implementation is complete.

#5 - 2017-01-14 04:59 AM - Alessandro Pasotti

There might be another issue in 2.18 and master:

Step to reproduce in GeoServer:

- enable WFS transactional in GeoServer

- add a WFS-T GeoServer shapefile layer to QGIS, set version=1.0.0

- enable editing
- add a new feature

- save

- end editing

- enable editing

- add a new feature

- save 

- end editing

- zoom in/out to refresh the canvas

Expected result: 2 new features appear in the map

Actual result: only 1 new feature appears in the map (the first added feature).

Note: the second feature was actually inserted in GeoServer, the problem is that QGIS does not notice it

#6 - 2017-01-14 05:28 AM - Alessandro Pasotti

The reason for the observed behavior is that GeoServer always return new0 as the feature id if the feature store does not support id generation as happen

in shapefiles.

#7 - 2017-01-14 05:44 AM - Even Rouault

The reason for the observed behavior is that GeoServer always return new0 as the feature id if the feature store does not support id generation as

happen in shapefiles.

Ouch, sounds like an issue of the server. The returned id is supposed to be unique...

#8 - 2017-01-14 06:33 AM - Alessandro Pasotti

It's unique within a single transaction.

#9 - 2017-01-14 07:24 AM - Anonymous

- Status changed from Open to Closed

Fixed in changeset commit:"93770b1c307fe42c910eb993c7d813931512ba75".

#10 - 2017-01-16 08:19 AM - Giovanni Manghi

- Status changed from Closed to Reopened

#11 - 2017-01-16 08:19 AM - Giovanni Manghi

- Resolution set to fixed/implemented

- Status changed from Reopened to Closed
